//*************************************************************************** //
//                                                                  //
//    -107-7                                                  //
//      LCD_PORT                                            //
//  A0 -  (0=0)/ (0=1)                                     //
//  WR1 -                                                         //
//  LCD_PORT 0..3 -  /
//****************************************************************************//

#include "lcd.h"
#include <avr/io.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>

//  
const unsigned char codesym[30] PROGMEM=
 {0xee,0x60,0x2f,0x6d,0xe1,0xcd,0xcf,0x68,0xef,0xed,
 // 0 , 1  ,  2 , 3  ,  4,   5  , 6  ,  7 , 8  , 9  ,  
  0xeb,0xc7,0x8e,0x67,0x8f,0x8b,0xce,0xe3,0x86,0x43,
 // A , b,   C  , d  ,  E , F  ,  g ,  H , L  , n,     
  0xab,0x03,0xcd,0x87,0xe6,0xe5,0xa9,0x01,0x47,0x00};
 // P , r  ,  S , t  ,  U , Y  ,-, -,-, 

//    ----------------------------------------------------------------
void write_lcd(void)
{
 LCD_PORT|=(1<<WR1);    //    
 _delay_us(10);
 LCD_PORT&=~(1<<WR1);
}

//   -------------------------------------------------------------------
void res_lcd(void)
{
 LCD_PORT=0x0F;         //    
 LCD_PORT&=~(1<<A0);    //   c A0=0
 write_lcd();		    // 

 LCD_PORT=0x01;         //   
 LCD_PORT|=(1<<A0);     //    A0=1
 write_lcd();		    // 
}

//    ---------------------------------------------------------
void clr_lcd(void)
{ unsigned char segcount;
 cli();
 res_lcd();             //  

 LCD_PORT=0x00;         //     
 LCD_PORT&=~(1<<A0);    //   c A0=0
 write_lcd();  		    // 

 for (segcount=0;segcount<20;segcount++) //     
 {
  LCD_PORT=0x00;         //  
  LCD_PORT|=(1<<A0);     //    A0=1
  write_lcd();		     // 
  //       
 }

 sei();                 //  
}

//    ------------------------------------------------------
void set_cursor_lcd(unsigned char cursor)
{
 cursor--;		// SG1..SG10   0x00..0x09
 LCD_PORT=cursor;       //   
 LCD_PORT&=~(1<<A0);    //  
 write_lcd();           // 
}

//     --------------------------------------------------------
//       0..9    
void out_sym_lcd(unsigned char sym)
{unsigned char code;
 code=pgm_read_byte(&codesym[sym]); //     flash

 LCD_PORT=mask(code);   //  
 LCD_PORT|=(1<<A0);     //  
 write_lcd();           // 

 LCD_PORT=(code>>4);    //  
 LCD_PORT|=(1<<A0);     //  
 write_lcd();           // 
}

//       0  65535 -------------------------------------
//         
//             0
void OUT_LCD(unsigned int a, unsigned char pos )
{ unsigned char R, R1, b;
  unsigned int X1;

  X1=a; b=pos;
  R=R1=0;
  while (X1>=10000)
  { X1=X1-10000;R++;
  }
  if (R!=0) {set_cursor_lcd(b-4); out_sym_lcd(R);R1++;}

  R=0;                  //  
  while (X1>=1000)
  { X1=X1-1000; R++;
  }
  if (R!=0) {R1++;}
  set_cursor_lcd(b-3); out_sym_lcd(R);

                   //  
  R=0;
  while (X1>=100)
  { X1=X1-100; R++;
  }
  out_sym_lcd(R);

  R=0;                 //    
  while (X1>=10)
  { X1=X1-10; R++;
  }
  out_sym_lcd(R);out_sym_lcd(X1);
  if (R1==0) {set_cursor_lcd(b-3);out_sym_lcd(29);} //   

}

