/*   UART 
      (16    )
 UART   9600 /

       UART 4800, 9600 
19200 /,   8  16  ,     
         
    EEPROM */

//  ATtiny2313,   4 ,  WinAVR20090313
//   FLASH 1964 , EEPROM 8 

#include <avr/io.h>		//   /
#include <util/delay.h>         //  
#include <avr/interrupt.h>      //  
#include <avr/eeprom.h>         //     eeprom
#include "lcd.h"                //      (   )


#define HI(x) ((x)>>8)          //   
#define LO(x) ((x)&0xFF)        //    
#define bd(x) ( F_CPU/16/x-1)   //    UART   

//     (  D)
#define SET 3                   //  SET
#define PLUS 4                  //  +
#define ENT 5                   //  ENT

//       
void menu1(void);    void menu2(void);    void menu3(void);    void menu4(void);
void control (void); void UART_DIV(unsigned int a);



//   EEPROM
unsigned char baud_div[3] EEMEM ={bd(4800),bd(9600),bd(19200)};//   UART
unsigned char nH1 EEMEM=0x02;    //      
unsigned char nH2 EEMEM=0x04;    //      
unsigned int baud_vel EEMEM=9600;//  UART
unsigned char data_f EEMEM=0x10; //   0x10-16 , 0x08-8 

//  
volatile unsigned char x0,x1,count;//  UART, ,  
unsigned int X;
unsigned char count_timer,menu;

//  (         iotn, iom)
ISR(BADISR_vect)	//   
{
 reti();
}

//~~~~~~~~~~~~~~~~~~~~  UART   ~~~~~~~~~~~~~~~~~~~~~~~~~~
ISR(USART_RX_vect)
{ unsigned char data;
 data=UDR; x0=x1; x1=data;      //       
 count++;                	//   
 while ((1<<UDRE)&&(UCSRA)==0)
  {                             //     
  }                             //    
 UDR=data;                      //  -  
}

// ************************************************************************** //
//                                                           //
// ************************************************************************** //
ISR (TIMER0_OVF_vect)   //     0
{

 count_timer++;         //  +1

 //~~~~~~~~    set ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 if (bit_is_clear(PIND, SET)) 
  { //~~~~~~~~        ~~~~~~~~~~~~~~~~~~~~~~~~
  
   TCCR0B=0x00;          //  
   _delay_ms(100);       //  
   while(bit_is_clear(PIND,SET));   //   
   _delay_ms(100);       //  
 
     for (menu=1;menu<5;menu++)     //  
      { clr_lcd();                  //  
       if (menu==1) {menu1();}
       if (menu==2) {menu2();}
       if (menu==3) {menu3();}
       if (menu==4) {menu4();}
       control();
      }
  clr_lcd();                        //  
  }


 // ~~~~~~~~~       ~~~~~~~~~~~~~ 

//     UART
 if (count_timer>=0x7A)  //    2
 { count_timer=0;       //    
   clr_lcd();           //     
   set_cursor_lcd(5);out_sym_lcd(26);
   set_cursor_lcd(10);out_sym_lcd(20);
 }
TCCR0B=0x04;            //  
}


//  ************************************************************************* //
//                    -                           //
// ************************************************************************** //
int main(void)
{
// ~~~~~~~~~~~~~~   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 ACSR=0x80;     //   

 //  
 DDRB=0xFF;     //  B  
 PORTB=0x00;

 DDRD=0x00;     //  D  
 PORTD=0x7C;    // PD2..PD6    Vcc

 //  0
 TCCR0A=0x00;   //  ,   
 TCCR0B=0x04;   // =256 f=4000000/256/256=61
 TIMSK=0x02;    //     0


//  UART

 UART_DIV(eeprom_read_word(&baud_vel)); //   

 UCSRA=0;
 UCSRB=1<<RXEN|1<<TXEN|1<<RXCIE;        //  , ,
					//    
 UCSRC=1<<UCSZ1|1<<UCSZ0;       	//   8 1

 sei();					//  
 x0=x1=count=count_timer=0;     	//   
 clr_lcd();             		//  


  while (1)// ****************   **************************
   {
   count_timer=0;       //   

// ~~~~~~~~~~~~~~~~~~        ~~~~~~~~~~~~~~~~~
    set_cursor_lcd(5);  out_sym_lcd(26); //   5    'o'
    set_cursor_lcd(10); out_sym_lcd(20); //   10    'P'

// ~~~~~~~~~~~~~~~~~~~  0.5 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    _delay_ms(500);

// ~~~~~~~~~~~~~~~~~~~   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    while ((x1!=0xFF)|(x0!=0xFF)); //   0xFF,0xFF      
    count=0;      //       
    
// ~~~~~~~~~~~~~~~~~~~  1-  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    while (count!=eeprom_read_byte(&nH1));
    X=256*x1+x0; if (X>9999) {X=9999;}
    if (eeprom_read_byte(&data_f)==0x08) {X=x1;}; //     8  
    OUT_LCD(X,4);

// ~~~~~~~~~~~~~~~~~~~  2-  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    while (count!=eeprom_read_byte(&nH2));
    X=256*x1+x0; if (X>9999) {X=9999;}
    if (eeprom_read_byte(&data_f)==0x08) {X=x1;}; //     8  
    OUT_LCD(X,9);
    
   }     // **************     *********************
 return 0;
}


// ************************************************************************** //
//                                           //
// ***************************************************************************//
void menu1(void)
{   set_cursor_lcd(1); out_sym_lcd(24); out_sym_lcd(10); //    "UA"
    X=eeprom_read_word(&baud_vel);
}

void menu2(void)
{    set_cursor_lcd(1); out_sym_lcd(13); out_sym_lcd(10);
     out_sym_lcd(23);out_sym_lcd(10);                    //    "data"
     X=eeprom_read_byte(&data_f);
}

void menu3(void)
{    set_cursor_lcd(1); out_sym_lcd(19); out_sym_lcd(17);
     out_sym_lcd(1);                                      //    "nH1"
     X=eeprom_read_byte(&nH1);
}

void menu4(void)
{    set_cursor_lcd(1); out_sym_lcd(19); out_sym_lcd(17);
     out_sym_lcd(2);                                     //    "nH2"
     X=eeprom_read_byte(&nH2);
}


void control(void)   //  
{    //   "SET"  "ENT"     
     while((bit_is_set(PIND, SET))&&(bit_is_set(PIND, ENT)))
     {
       if (bit_is_clear(PIND,PLUS)) //   "+"
       {
	 if (menu==1)    //   UART
	 {
	   switch (X)
	   { case 19200: {X=4800; set_cursor_lcd(6);out_sym_lcd(29);} break;
	     case 4800: {X=9600;} break;
	     case 9600: {X=19200;} break;
	     default: {X=9600;} break;
	   }
	   
	 }
	 if (menu==2)    //   16  8 
	 {  if(X==0x08) {X=0x10;} else {X=0x08;}
	 }
	 if (menu>=3)    //    
	 {   X++; if (X>16) {X=1;}
	 }
       }
       _delay_ms(100);  //    "+"
        OUT_LCD(X,10);	//  
     }

    if(bit_is_clear(PIND,ENT)) //     ENT  
     {
       switch (menu)
       {  case 1: {eeprom_write_word(&baud_vel,X);UART_DIV(X);} break;
	  case 2: {eeprom_write_byte(&data_f,X);} break;
          case 3: {eeprom_write_byte(&nH1,X);} break;
          case 4: {eeprom_write_byte(&nH2,X);} break;
       }
     }
     _delay_ms(100);    //  
}

void UART_DIV(unsigned int a)          //     
{  unsigned char baud_divider, i;
    switch (a)
    { case 4800: {i=0;} break;
      case 9600: {i=1;} break;
      case 19200: {i=2;} break;
      default: {i=1;} break;
    }
    baud_divider=eeprom_read_byte(&baud_div[i]);    //     
    UBRRL=LO(baud_divider); UBRRH=HI(baud_divider);
}

